
#property  copyright ""
#property  link      ""

//
//
//
//
//

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     LimeGreen
#property indicator_color2     Red
#property indicator_color3     PaleVioletRed
#property indicator_color4     DeepSkyBlue
#property indicator_width1     3
#property indicator_width2     3
#property indicator_width3     2
#property indicator_width4     2
#property indicator_level1     0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Gold

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE BBPrice         = 0;
extern double             BBPeriod        = 13;
extern double             T3Period        = 2.5;
extern double             T3Hot           = 1.0; 
extern bool               T3Original      = false; 
extern bool               alertsOn        = false;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = false;
extern bool               alertsEmail     = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double BearsBuff[];
double BullsBuff[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double cross[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
   IndicatorBuffers(8);   
   SetIndexBuffer(0,Buffer1);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,BearsBuff);
   SetIndexBuffer(3,BullsBuff);
   SetIndexBuffer(4,Buffer3);
   SetIndexBuffer(5,Buffer4);
   SetIndexBuffer(6,Buffer5);
   SetIndexBuffer(7,cross);
   
      //
      //
      //
      //
      //
     
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
  IndicatorShortName(timeFrameToString(TimeFrame)+"   Bulls Bears Ac ("+DoubleToStr(BBPeriod,2)+","+DoubleToStr(T3Period,2)+")");
return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer1[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for (i=limit; i>=0; i--) Buffer3[i] = iMA(NULL,0,5,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,34,0,MODE_SMA,PRICE_MEDIAN,i);
     for (i=limit; i>=0; i--) Buffer4[i] = iMAOnArray(Buffer3,0,5,0,MODE_SMA,i);
     for (i=limit; i>=0; i--)
     { 
        Buffer5[i] = Buffer3[i] - Buffer4[i]; 
        Buffer1[i] = EMPTY_VALUE;
        Buffer2[i] = EMPTY_VALUE;
   
   
        if (Buffer5[i]  > Buffer5[i+1]) 
             Buffer1[i] = Buffer5[i]; 
        else Buffer2[i] = Buffer5[i];
        double cprice   = iMA(NULL,0,BBPeriod,0,MODE_SMA,BBPrice,i);
        BearsBuff[i]    = iT3(cprice-Low[i], T3Period,T3Hot,T3Original,i,0);
        BullsBuff[i]    = iT3(High[i]-cprice,T3Period,T3Hot,T3Original,i,1);
        cross[i]        = cross[i+1];
         if (BearsBuff[i]>BullsBuff[i]) cross[i] = -1;
         if (BearsBuff[i]<BullsBuff[i]) cross[i] =  1;
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {   
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Buffer1[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BBPrice,BBPeriod,T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
         Buffer2[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BBPrice,BBPeriod,T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,1,y);
         BearsBuff[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BBPrice,BBPeriod,T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,2,y);
         BullsBuff[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,BBPrice,BBPeriod,T3Period,T3Hot,T3Original,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,3,y);
         
    }
   return(0);
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
            
         static datetime time1 = 0;
         static string   mess1 = "";
            if (cross[whichBar] ==  1) doAlert(time1,mess1," bull crossed bear up");
            if (cross[whichBar] == -1) doAlert(time1,mess1," bear crossed bull up");
   }            
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" bull bear",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workT3[][12];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int i, int instanceNo=0)
{
   if (ArrayRange(workT3,0) != Bars)                ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (instanceNo+1)) ArrayResize(workT3Coeffs,instanceNo+1);

   if (workT3Coeffs[instanceNo][_period] != period)
   {
     workT3Coeffs[instanceNo][_period] = period;
        double a = hot;
            workT3Coeffs[instanceNo][_c1] = -a*a*a;
            workT3Coeffs[instanceNo][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[instanceNo][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[instanceNo][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[instanceNo][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[instanceNo][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = instanceNo*6;
   int r = Bars-i-1;
   if (r == 0)
      {
         workT3[r][0+buffer] = price;
         workT3[r][1+buffer] = price;
         workT3[r][2+buffer] = price;
         workT3[r][3+buffer] = price;
         workT3[r][4+buffer] = price;
         workT3[r][5+buffer] = price;
      }
   else
      {
         workT3[r][0+buffer] = workT3[r-1][0+buffer]+workT3Coeffs[instanceNo][_alpha]*(price              -workT3[r-1][0+buffer]);
         workT3[r][1+buffer] = workT3[r-1][1+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][0+buffer]-workT3[r-1][1+buffer]);
         workT3[r][2+buffer] = workT3[r-1][2+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][1+buffer]-workT3[r-1][2+buffer]);
         workT3[r][3+buffer] = workT3[r-1][3+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][2+buffer]-workT3[r-1][3+buffer]);
         workT3[r][4+buffer] = workT3[r-1][4+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][3+buffer]-workT3[r-1][4+buffer]);
         workT3[r][5+buffer] = workT3[r-1][5+buffer]+workT3Coeffs[instanceNo][_alpha]*(workT3[r][4+buffer]-workT3[r-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[instanceNo][_c1]*workT3[r][5+buffer] + 
          workT3Coeffs[instanceNo][_c2]*workT3[r][4+buffer] + 
          workT3Coeffs[instanceNo][_c3]*workT3[r][3+buffer] + 
          workT3Coeffs[instanceNo][_c4]*workT3[r][2+buffer]);
}


